=== debian/changelog ===
colobot (0.1.8-2build2) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:14:14 +0000

colobot (0.1.8-2build1) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Aug 2016 08:15:27 +0000

colobot (0.1.8-2) unstable; urgency=medium

  * Move xmlstarlet from B-D-I to B-D; fixes arch-only FTBFS

 -- Didier Raboud <odyx@debian.org>  Mon, 11 Jul 2016 20:12:04 +0200

colobot (0.1.8-1) unstable; urgency=medium

  * New upstream release: 0.1.8

  * Bump S-V to 3.9.8 without changes needed
  * Add xmlstarlet as B-D needed for the new SVG resizing code

 -- Didier Raboud <odyx@debian.org>  Mon, 11 Jul 2016 10:39:08 +0200
