=== debian/changelog ===
colobot (0.1.9-5) unstable; urgency=medium

  * Add patch to find the available level translations with a sorted
    os.listdir, to avoid picking unreproducibilty from the directory files
    order

 -- Didier Raboud <odyx@debian.org>  Sat, 17 Dec 2016 14:10:44 +0100

colobot (0.1.9-4) unstable; urgency=medium

  * Update oggenc-reproducibility patch to use the original file's bytesize as
    --serial integer (Closes: #846976)

 -- Didier Raboud <odyx@debian.org>  Mon, 05 Dec 2016 13:35:48 +0100

colobot (0.1.9-3) unstable; urgency=medium

  * Revert "Patch hippomocks to broaden its architecture support"
  * Allow tests to fail on architectures without support in hippomocks,
    circumvent the FTBFS

 -- Didier Raboud <odyx@debian.org>  Tue, 08 Nov 2016 20:36:37 +0100

colobot (0.1.9-2) unstable; urgency=medium

  * Patch hippomocks to broaden its architecture support.
    This should fix the mips* and arm64 FTBFS'es.
    Thanks-to: Philippe Coval <philippe.coval@osg.samsung.com>

 -- Didier Raboud <odyx@debian.org>  Mon, 07 Nov 2016 08:37:19 +0100

colobot (0.1.9-1) unstable; urgency=medium

  * New upstream release: 0.1.9

  * Build and run unit tests
  * Set the 'Official Build' flag
  * Make all arch:all packages Multi-Arch: foreign
  * Reproducibility patches:
    - Patch the flac-to-ogg conversion to use the filename as ogg serial number
    - Patch the Doxygen configuration to avoid embedding the build path in the
      documentation

 -- Didier Raboud <odyx@debian.org>  Fri, 04 Nov 2016 12:04:36 +0100
