=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: colobot
 Section: games
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders:
  Didier Raboud <odyx@debian.org>
 Build-Depends:
@@ -60,6 +59,7 @@
 
 Package: colobot-common
 Architecture: all
+Multi-Arch: foreign
 Depends:
  ${misc:Depends}
 Recommends:
@@ -75,6 +75,7 @@
 
 Package: colobot-common-textures
 Architecture: all
+Multi-Arch: foreign
 Depends:
  ${misc:Depends}
 Recommends:
@@ -94,6 +95,7 @@
 
 Package: colobot-common-sounds
 Architecture: all
+Multi-Arch: foreign
 Depends:
  ${misc:Depends}
 Recommends:
@@ -113,6 +115,7 @@
 
 Package: colobot-dev-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Depends:
  libjs-jquery,
