=== debian/changelog ===
colobot (0.1.10-2build1) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 17:12:41 +0000

colobot (0.1.10-2) unstable; urgency=medium

  * Migrate 0.1.10 to unstable
  * Bump Standards-Version to 4.0.0 without changes needed
  * Migrate to debhelper compat 10

 -- Didier Raboud <odyx@debian.org>  Sun, 23 Jul 2017 11:27:51 +0200

colobot (0.1.10-1) experimental; urgency=low

  * New upstream release: 0.1.10

 -- Didier Raboud <odyx@debian.org>  Tue, 30 May 2017 16:37:44 +0200
