=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  Didier Raboud <odyx@debian.org>
 Build-Depends:
  cmake,
- debhelper (>= 9.20151219~),
+ debhelper (>= 10.2.5~),
  google-mock,
  imagemagick,
  libboost-dev,
@@ -33,7 +33,7 @@
  vorbis-tools,
 Vcs-Git: https://alioth.debian.org/anonscm/git/pkg-games/colobot.git -b debian
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/colobot.git
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: http://colobot.info
 
 Package: colobot
